/*
  disp_mediatype.cpp@Ver.1.02i
  MediaTypȅڍו\Tu[`

  AM_MEDIA_TYPE *amt;
  disp_mediatype(amt);
  
  Ver.1.00 2011/03/01 disp_mediatype.fƗ[`AB  
  Ver.1.01 2011/06/29 GUID\̂Ȃ̂ŁA|C^Ă݂B
  Ver.1.02 2011/07/22 FOURCC̕\𐮗
*/
#include <stdio.h>
#include <stdlib.h>
#include <dshow.h>
#include <Dvdmedia.h>
#include <Mmreg.h>

#include "disp_mediatype.h"
#pragma comment (lib,"strmiids.lib")

void disp_guid(const GUID *guid)
{
  if(guid == NULL) { printf("(null)\n"); return; }
  printf("{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
	 guid->Data1,guid->Data2,guid->Data3,
	 guid->Data4[0],guid->Data4[1],guid->Data4[2],guid->Data4[3],
	 guid->Data4[4],guid->Data4[5],guid->Data4[6],guid->Data4[7]);
}

// FOURCCł邩ۂ𔻒
int is_forcc_guid(const GUID *guid)
{
  return((   guid->Data2 == 0x0000)
	 && (guid->Data3 == 0x0010)
	 && (guid->Data4[0] == 0x80)
	 && (guid->Data4[1] == 0x00)
	 && (guid->Data4[2] == 0x00)
	 && (guid->Data4[3] == 0xaa)
	 && (guid->Data4[4] == 0x00)
	 && (guid->Data4[5] == 0x38)
	 && (guid->Data4[6] == 0x9b)
	 && (guid->Data4[7] == 0x71));
}

static void print_char(const unsigned char c)
{
  if(isgraph(c))
    {
      putchar(c);
      return;
    }
  printf("[%02x]",c);
  return;
}

// FOURCC\
void print_forcc(const GUID *guid)
{
  printf("FOURCC'");
  print_char((guid->Data1 >>  0) & 0xff);
  print_char((guid->Data1 >>  8) & 0xff);
  print_char((guid->Data1 >> 16) & 0xff);
  print_char((guid->Data1 >> 24) & 0xff);
  printf("'");
}

// C++ƈӖȂȂ
int is_same_guid(const GUID *id1,const GUID *id2)
{
#ifdef __cplusplus
  return((*id1)==(*id2));
#else
  return((id1->Data1==id2->Data1)&&(id1->Data2==id2->Data2)&&(id1->Data3==id2->Data3)
	 &&(id1->Data4[0]==id2->Data4[0])&&(id1->Data4[1]==id2->Data4[1])
	 &&(id1->Data4[2]==id2->Data4[2])&&(id1->Data4[3]==id2->Data4[3])
	 &&(id1->Data4[4]==id2->Data4[4])&&(id1->Data4[5]==id2->Data4[5])
	 &&(id1->Data4[6]==id2->Data4[6])&&(id1->Data4[7]==id2->Data4[7]));
#endif
}

// GUID̕\: -1 : GUID_NULL -2 : FOURCĈ -10: Sɕs
int disp_media_guid_list(const GUID *guid,media_guid_list *list)
{
  int i;
  if(list == NULL) return(-100);
  i = 0;
  while(list[i].list != NULL)
    {
      if(is_same_guid(guid,list[i].guid))
	{
	  printf(list[i].list);
	  if(is_forcc_guid(guid)) // FOURCCłꍇɕ\
	    {
	      printf("(");
	      print_forcc(guid);
	      printf(")");
	    }
	  return(i);
	}
      i++;
    }
  if(is_forcc_guid(guid)) // FOURCCꍇɕ\
    {
      print_forcc(guid);
      return(-2);
    }
  if(is_same_guid(guid,list[i].guid)) // Ō̂̂Ɉv
    {
      printf("GUID_NULL");
      return(-1);
    }
  // m̂
#if 0
  printf("Unknown.");
#endif
  return(-3);
}

typedef struct{
  DWORD value;
  char *list;
} dword_list;

// DWORD̕\
int disp_dword_list(const DWORD value,dword_list *list)
{
  int i;
  if(list == NULL) return(-100);
  i = 0;
  while(list[i].list != NULL)
    {
      if(value == list[i].value)
	{
	  printf("(%s)",list[i].list);
	  return(i);
	}
      i++;
    }
  // m̂
  if(i != 0) i--;
  printf("(%s)",list[i].list);
  return(-1);
}

// DWORD̕\(flag^)
int disp_dword_flag(const DWORD value,dword_list *list)
{
  int i;
  if(list == NULL) return(-100);
  i = 0;
  while(list[i].list != NULL)
    {
      if(value & list[i].value)
	{
	  printf("(%s)",list[i].list);
	}
      i++;
    }
  return(0);
}

media_guid_list formattype[] ={
  {&FORMAT_None,		"None"},
  {&FORMAT_DvInfo,		"Dv"},		// DvInfo
  {&FORMAT_MPEGVideo,		"MPEG"},	// MPEGVideo
  {&FORMAT_MPEG2Video,		"MPEG2"},	// MPEG2Video
  {&FORMAT_VideoInfo,		"Video"},	// VideoInfo
  {&FORMAT_VideoInfo2,		"Video2"},	// VideoInfo2
  {&FORMAT_WaveFormatEx,	"Wave"},	// WaveFormatEx
  {&GUID_NULL,NULL}};

void disp_formattype(const GUID *guid)
{
  if(disp_media_guid_list(guid,formattype) <= -10)
    {
      disp_guid(guid);
    }
}

media_guid_list mediasubtype[] = {
  {&MEDIASUBTYPE_PCM,"PCMI[fBI"},
  {&MEDIASUBTYPE_MPEG1Packet,"MPEG1I[fBIPacket"},
  {&MEDIASUBTYPE_MPEG1Payload,"MPEG1I[fBIPayload"},
  {&MEDIASUBTYPE_MPEG2_AUDIO,"MPEG-2I[fBI"},
  {&MEDIASUBTYPE_DVD_LPCM_AUDIO,"DVDI[fBI"},
  {&MEDIASUBTYPE_MPEG2_AUDIO,"MPEG-2I[fBI"},
  {&MEDIASUBTYPE_DRM_Audio,"WAVE_FORMAT_DRMɑΉ"},
  {&MEDIASUBTYPE_IEEE_FLOAT,"WAVE_FORMAT_IEEE_FLOATɑΉ"},
  {&MEDIASUBTYPE_DOLBY_AC3,"Dolby f[^B"},
  {&MEDIASUBTYPE_DOLBY_AC3_SPDIF,"SPDIFDolbyAC3"},
  {&MEDIASUBTYPE_RAW_SPORT,"MEDIASUBTYPE_DOLBY_AC3_SPDIFƓ"},
  {&MEDIASUBTYPE_SPDIF_TAG_241h,"MEDIASUBTYPE_DOLBY_AC3_SPDIFƓ"},
  {&MEDIASUBTYPE_RGB1,"RGB1(1bpp)"},
  {&MEDIASUBTYPE_RGB4,"RGB4(4bpp)"},
  {&MEDIASUBTYPE_RGB8,"RGB8(8bpp)"},
  {&MEDIASUBTYPE_RGB555,"RGB555(16bpp)"},
  {&MEDIASUBTYPE_RGB565,"RGB565(16bpp)"},
  {&MEDIASUBTYPE_RGB24,"RGB24(24bpp)"},
  {&MEDIASUBTYPE_RGB32,"RGB32(32bpp)"},
  {&MEDIASUBTYPE_ARGB32,"ARGB(32 bpp)"},
  {&MEDIASUBTYPE_AYUV,"AYUV(4:4:4)"},
  {&MEDIASUBTYPE_UYVY,"UYVY(4:2:2)"},
  {&MEDIASUBTYPE_Y411,"Y411(4:1:1)"},
  {&MEDIASUBTYPE_Y41P,"Y41P(4:1:1)"},
  {&MEDIASUBTYPE_Y211,"Y211"},
  {&MEDIASUBTYPE_YUY2,"YUY2(4:2:2)"},
  {&MEDIASUBTYPE_YVYU,"YVYU(4:2:2)"},
  {&MEDIASUBTYPE_YUYV,"YUYV"},
  {&MEDIASUBTYPE_CFCC,"MJPG('CFCC')"},
  {&MEDIASUBTYPE_CLJR,"CLJR('CLJR')"},
  {&MEDIASUBTYPE_CPLA,"CinepakUYVY('CPLA')"},
  {&MEDIASUBTYPE_CLPL,"CirrusLogicYUV('CLPL')"},
  {&MEDIASUBTYPE_IJPG,"IntergraphJPEG('IJPG')"},
  {&MEDIASUBTYPE_MDVF,"DVencoded('MDVF')"},
  {&MEDIASUBTYPE_MJPG,"MotionJPEG('MJPG')"},
  {&MEDIASUBTYPE_MPEG1Packet,"MPEG1rfI pPbg"},
  {&MEDIASUBTYPE_MPEG1Payload,"MPEG1rfI yC[h"},
  {&MEDIASUBTYPE_Overlay,"n[hEFAI[o[CgĔzMrfI"},
  {&MEDIASUBTYPE_Plum,"PlumMJPG('Plum')"},
  {&MEDIASUBTYPE_QTJpeg,"Quicktime JPEG k"},
  {&MEDIASUBTYPE_QTMovie,"Apple(c)QuickTime(c)k"},
  {&MEDIASUBTYPE_QTRle,"QuicktimeRLEk"},
  {&MEDIASUBTYPE_QTRpza,"QuicktimeRPZA k"},
  {&MEDIASUBTYPE_QTSmc,"QuicktimeSMC k"},
  {&MEDIASUBTYPE_TVMJ,"TrueVisionMJPG('TVMJ')"},
  {&MEDIASUBTYPE_VPVBI,"rfI|[gԊu(VBI)"},
  {&MEDIASUBTYPE_VPVideo,"rfI|[grfI"},
  {&MEDIASUBTYPE_WAKE,"ꕔ̃J[hɂĐMJPG('WAKE')"},
  // MPEG2 stream
  {&MEDIASUBTYPE_MPEG2_VIDEO,"MPEG2_VIDEO"},
  {&MEDIASUBTYPE_MPEG2_PROGRAM,"MPEG2_PROGRAM"},
  {&MEDIASUBTYPE_MPEG2_TRANSPORT,"MPEG2_TRANSPORT"},
  // -----------------------------ȉAs
  {&MEDIASUBTYPE_Avi,"Avi"},
  {&GUID_NULL,NULL}};

void disp_subtype(const GUID *guid)
{
  if(disp_media_guid_list(guid,mediasubtype) <= -10)
    {
      printf("Unknown."); disp_guid(guid);
    }
}

media_guid_list mediamajortype[] = {
  {&MEDIATYPE_Audio,"Audio"}, // Audio
  {&MEDIATYPE_Video,"Video"}, // Video
  {&MEDIATYPE_Stream,"Stream"}, // Stream
  {&GUID_NULL,NULL}};

void disp_majortype(const GUID *guid)
{
  if(disp_media_guid_list(guid,mediamajortype) <= -10)
    {
      printf("Unknown."); disp_guid(guid);
    }
}

void disp_bitmapinfoheader(BITMAPINFOHEADER *bih)
{
  if(bih != NULL)
    {
      printf("(%d,%d)",bih->biWidth,bih->biHeight);
    }
}

void disp_videoinfoheader(VIDEOINFOHEADER *vih)
{
  if(vih != NULL)
    {
      printf("[%.2ffps(%.4fms)]",10000000.0/(vih->AvgTimePerFrame),vih->AvgTimePerFrame/10000.0);
      if(vih->dwBitRate != 0.0)
	{
	  printf("(%.2fMbps)",(double)(vih->dwBitRate)/1000000.0);
	}
      //قƂǂ̏ꍇErrorRate[Ȃ̂Ŕ\ɂ
      //printf("(Err%dbps)",vih->dwBitErrorRate);
    }
}

dword_list vih2_flag[] = {
    {AMINTERLACE_IsInterlaced,"Interlaced"},
    {AMINTERLACE_1FieldPerSample,"1Field"},
    {AMINTERLACE_Field1First,"Field1First"},
    {0,NULL}};
dword_list vih2_patternmask[] = {
    {AMINTERLACE_FieldPatField1Only,"Field1Only"}, // Xg[ɃtB[h 2 ͂ȂB
    {AMINTERLACE_FieldPatField2Only,"Field2Only"}, // Xg[ɃtB[h 1 ͂ȂB
    {AMINTERLACE_FieldPatBothRegular,"BothRegular"}, // tB[h 1 ƂɃtB[h 2 K 1 B
    {AMINTERLACE_FieldPatBothIrregular,"BothIrregular"}, // tB[h 1 ƃtB[h 2 sKɔzuĂB
    {0,NULL}};
dword_list vih2_modemask[] = {
    {AMINTERLACE_DisplayModeBobOnly,"BobOnly"}, // fBXvC [h̓{û݁B
    {AMINTERLACE_DisplayModeWeaveOnly,"WeaveOnly"}, // fBXvC [h̓EB[û݁B
    {AMINTERLACE_DisplayModeBobOrWeave,"BobOrWeave"}, // {uƃEB[ũ̗[hB
    {0,NULL}};

void disp_videoinfoheader2(VIDEOINFOHEADER2 *vih2)
{
  if(vih2 != NULL)
    {
      disp_dword_flag(vih2->dwInterlaceFlags,vih2_flag);
      disp_dword_list((vih2->dwInterlaceFlags & AMINTERLACE_FieldPatternMask),vih2_patternmask);
      disp_dword_list((vih2->dwInterlaceFlags & AMINTERLACE_DisplayModeMask),vih2_modemask);
    }
}
  
void disp_waveformatex(WAVEFORMATEX *wf)
{
  if(wf != NULL)
    {
      if(wf->wFormatTag == WAVE_FORMAT_PCM) printf(" WAVE_FORMAT_PCM");
      printf("(%dch)",wf->nChannels);
      printf("(%dSamplesPerSec)",wf->nSamplesPerSec);
      printf("(%dbits)",wf->wBitsPerSample);
      printf("(%d)",wf->nBlockAlign); //ubNTCY
      printf("(%d)",wf->cbSize); //ǉwb_TCY
    }
}

void disp_mpeg1videoinfo(MPEG1VIDEOINFO *m1vi)
{
  if(m1vi != NULL)
    {
      printf("(Time:%d)",m1vi->dwStartTimeCode);
      printf("(Size:%d)",m1vi->cbSequenceHeader);
    }
}

dword_list m2vi_profile[] = {
    {AM_MPEG2Profile_Simple,"Simple profile"},
    {AM_MPEG2Profile_Main,"Main profile"},
    {AM_MPEG2Profile_SNRScalable,"Signal to Noise Ratio (SNR) scalable profile"},
    {AM_MPEG2Profile_SpatiallyScalable,"Spatially scalable profile"},
    {AM_MPEG2Profile_High,"High profile"},
    {0,"Unknown profile"},
    {0,NULL}};

dword_list m2vi_level[] = {
    {AM_MPEG2Level_Low,"Low level"},
    {AM_MPEG2Level_Main,"Main level"},
    {AM_MPEG2Level_High1440,"High 1440 level"},
    {AM_MPEG2Level_High,"High level"},
    {0,"Unknown level"},
    {0,NULL}};

dword_list m2vi_flag[] = {
    {AMMPEG2_DoPanScan,"DoPanScan"},
    {AMMPEG2_DVDLine21Field1,"DVDLine21Field1"},
    {AMMPEG2_DVDLine21Field2,"DVDLine21Field2"},
    {AMMPEG2_SourceIsLetterboxed,"SourceIsLetterboxed"},
    {AMMPEG2_FilmCameraMode,"FilmCameraMode"},
    {AMMPEG2_LetterboxAnalogOut,"LetterboxAnalogOut"},
    {AMMPEG2_DSS_UserData,"DSS_UserData"},
    {AMMPEG2_DVB_UserData,"DVB_UserData"},
    {AMMPEG2_27MhzTimebase,"27MhzTimebase"},
    {AMMPEG2_WidescreenAnalogOut,"WidescreenAnalogOut"},
    {0,NULL}};


void disp_mpeg2videoinfo(MPEG2VIDEOINFO *m2vi)
{
   if(m2vi != NULL)
    {
      printf("(Time:%d)",m2vi->dwStartTimeCode);
      printf("(Size:%d)",m2vi->cbSequenceHeader);
      disp_dword_list(m2vi->dwProfile,m2vi_profile);
      disp_dword_list(m2vi->dwLevel,m2vi_level);
      disp_dword_flag(m2vi->dwFlags,m2vi_flag);
    }
}

void disp_mediatype(const AM_MEDIA_TYPE *amt)
{
  VIDEOINFOHEADER *vih;
  VIDEOINFOHEADER2 *vih2;
  BITMAPINFOHEADER *bih;
  WAVEFORMATEX *wf;
  MPEG1VIDEOINFO *m1vi;
  MPEG2VIDEOINFO *m2vi;
  
  disp_majortype(&(amt->majortype));
  printf(" ");
  disp_subtype(&(amt->subtype));
  printf(" ");
  disp_formattype(&(amt->formattype));

  vih = NULL;
  vih2 = NULL;
  bih = NULL;
  wf = NULL;
  m1vi = NULL;
  m2vi = NULL;

  if((amt->formattype == FORMAT_VideoInfo) || (amt->formattype == FORMAT_MPEGVideo))
    {
      vih = (VIDEOINFOHEADER *)amt->pbFormat; // MPEG1VIDEOINFO\̂̐擪VIDEOINFOHEADER
      if(vih != NULL) bih = &(vih->bmiHeader);
    }
  if((amt->formattype == FORMAT_VideoInfo2) || (amt->formattype == FORMAT_MPEG2Video))
    {
      vih2 = (VIDEOINFOHEADER2 *)amt->pbFormat; // MPEG2VIDEOINFO\̂̐擪VIDEOINFOHEADER2
      if(vih2 != NULL) bih = &(vih2->bmiHeader);
    }
  if(amt->formattype == FORMAT_WaveFormatEx)
    {
      wf = (WAVEFORMATEX *)amt->pbFormat;
    }
  if(amt->formattype == FORMAT_MPEGVideo)
    {
      m1vi = (MPEG1VIDEOINFO *)amt->pbFormat;
    }
  if(amt->formattype == FORMAT_MPEG2Video)
    {
      m2vi = (MPEG2VIDEOINFO *)amt->pbFormat;
    }

  printf(" ");
  disp_bitmapinfoheader(bih);

  if(vih2 != NULL) vih = (VIDEOINFOHEADER *)vih2; // VIDEOINFOHEADER2VIDEOINFOHEADER܂
  disp_videoinfoheader(vih);
  disp_videoinfoheader2(vih2);

  disp_waveformatex(wf);

  disp_mpeg1videoinfo(m1vi);
  disp_mpeg2videoinfo(m2vi);

  printf("\n");
}
